SystemOrganization addCategory: #'JLLT-EditorsTest'!

Object subclass: #Customer
	instanceVariableNames: 'name phones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JLLT-EditorsTest'!

!Customer class methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 22:17'!
named: aString phones: ACollectionOfPhones

	^self new inititializeNamed: aString phones: ACollectionOfPhones
! !

!Customer methodsFor: 'as yet unclassified' stamp: 'JLLT 5/22/2009 11:17'!
addPhone: aPhone after: anotherPhone

	phones add: aPhone after: anotherPhone! !

!Customer methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:06'!
initialize

	phones := OrderedCollection new.! !

!Customer methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:22'!
inititializeNamed: aString phones: aCollectionOfPhones

	name := aString.
	phones := aCollectionOfPhones! !

!Customer methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:49'!
name

	^name! !

!Customer methodsFor: 'as yet unclassified' stamp: 'JLLT 5/21/2009 00:04'!
name: anObject

	name := anObject! !

!Customer methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 21:43'!
phones

	^phones copy! !

Object subclass: #Phone
	instanceVariableNames: 'number type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JLLT-EditorsTest'!

!Phone class methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:27'!
number: aString type: anotherString

	^ self new initializeNumber: aString type: anotherString! !

!Phone methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:29'!
initializeNumber: aString type: anotherString

	number := aString.
	type := anotherString! !

!Phone methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:23'!
number

	^number! !

!Phone methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:23'!
number: aString

	number := aString! !

!Phone methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:24'!
type

	^type! !

!Phone methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:24'!
type: aString

	type := aString! !

WAComponent subclass: #CustomerEditor
	instanceVariableNames: 'customer phoneReport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JLLT-EditorsTest'!

!CustomerEditor class methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 21:29'!
customer

	^customer! !

!CustomerEditor class methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 21:29'!
customer: anObject

	customer := anObject! !

!CustomerEditor class methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 21:29'!
renderButtonsOn: html

	html div: [
		html submitButton callback: [ self answer: true ]; value: 'Save'. 
		html submitButton callback: [ self answer: false ]; value: 'Cancel' ]! !

!CustomerEditor class methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 21:28'!
renderContentOn: html

	html form: [ 
		self renderNameInputOn: html.
		self renderButtonsOn: html ]
! !

!CustomerEditor class methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 21:28'!
renderNameInputOn: html.

     html text: 'Name'.
	html textInput on: #name of: self customer.! !

!CustomerEditor methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 22:35'!
children

	^Array with: phoneReport! !

!CustomerEditor methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:07'!
customer

	^customer! !

!CustomerEditor methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:07'!
customer: anObject

	^customer := anObject! !

!CustomerEditor methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 23:48'!
initialize

	super initialize.
	phoneReport := PhoneReport new! !

!CustomerEditor methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 21:30'!
renderButtonsOn: html

	html div: [
		html submitButton callback: [ self answer: true ]; value: 'Save'. 
		html submitButton callback: [ self answer: false ]; value: 'Cancel' ]! !

!CustomerEditor methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 23:47'!
renderContentOn: html

	html form: [ 
		self renderNameInputOn: html.
		phoneReport customer: customer.
		html render: phoneReport.
		self renderButtonsOn: html ]
! !

!CustomerEditor methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 21:31'!
renderNameInputOn: html.

     html text: 'Name'.
	html textInput on: #name of: self customer.! !

WAComponent subclass: #CustomerReport
	instanceVariableNames: 'customers customerEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JLLT-EditorsTest'!

!CustomerReport class methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:42'!
canBeRoot

	^true! !

!CustomerReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 22:34'!
children

	^Array with: customerEditor! !

!CustomerReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:47'!
customers

	^self sampleCustomers! !

!CustomerReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 23:44'!
editCustomer: aCustomer

	customerEditor customer: aCustomer.
	( self call: customerEditor )
		ifTrue: [ aCustomer copyFrom: customerEditor customer ]! !

!CustomerReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:11'!
initialize

	super initialize.
	customerEditor := CustomerEditor new.! !

!CustomerReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 22:12'!
renderContentOn: html

	html table: [
		self renderHeaderRowOn: html.
		self sampleCustomers do: [ :customer | 
			self renderCustomerRowFor: customer On: html ]]! !

!CustomerReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:51'!
renderCustomerRowFor: aCustomer On: html

	html tableRow: [
		html tableData: [ html text: aCustomer name ].
		html tableData: [ html anchor callback: [ self editCustomer: aCustomer ]; with: 'Edit']]! !

!CustomerReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/19/2009 23:37'!
renderHeaderRowOn: html

	html tableRow: [
		html tableData: [ html text: 'Name'].
		html tableData: [ html text: 'Edit']]! !

!CustomerReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 22:20'!
sampleCustomers
| phones |
	phones := OrderedCollection new.
	phones 
		add: ( Phone number: '5551113333' type: 'Home' );
		add: ( Phone number: '5552224444' type: 'Work').
	^Array 
		with: ( Customer named: 'Carl' phones: phones )! !

WAComponent subclass: #PhoneAdder
	instanceVariableNames: 'phone targetPhone customer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JLLT-EditorsTest'!

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/20/2009 22:31'!
phone
	^ phone! !

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/20/2009 23:53'!
phone: anObject

	phone := anObject! !

!PhoneAdder methodsFor: 'as yet unclassified' stamp: 'JLLT 5/22/2009 10:57'!
prepareToAdd: aPhone after: anotherPhone in: aCustomer

	phone := aPhone.
	targetPhone := anotherPhone.
	customer := aCustomer! !

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/22/2009 11:13'!
renderButtonsOn: html
	html submitButton callback: [ self answer: true ]; value: 'Save'.
	html submitButton callback: [self answer: false ]; value: 'Cancel'.! !

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/22/2009 11:10'!
renderContentOn: html

	html table: [ 
		self renderHeaderRowOn: html.
		customer phones do: [ :phone |
			self renderRowFor: phone on: html.
			phone = targetPhone
				ifTrue: [ self renderEditorRowOn: html ]]]! !

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/22/2009 11:12'!
renderEditorRowOn: html

	html tableRow: [
		html tableData: [ self renderNumberInputOn: html ].
		html tableData: [ self renderTypeInputOn: html ].
		html tableData: [ self renderButtonsOn: html ]]! !

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/22/2009 11:13'!
renderHeaderRowOn: html.

	html tableHead: [
		html tableRow with: [
			html tableData: [ html text: 'Number' ].			
			html tableData: [ html text: 'Type' ].
			html tableData: [ html text: '']]]! !

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/22/2009 11:04'!
renderNumberInputOn: html

	html textInput on: #number of: phone! !

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/22/2009 11:13'!
renderRowFor: aPhone on: html

	html tableRow with: [
		html tableData: [ html text: aPhone number ].
		html tableData: [ html text: aPhone type ].
		html tableData: [ html text: '']]! !

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/22/2009 11:02'!
renderTypeInputOn: html

	html select addAll: self typeOptions;
	on: #type of: phone! !

!PhoneAdder methodsFor: 'accessing' stamp: 'JLLT 5/22/2009 11:03'!
typeOptions

	^Array with: 'Home' with: 'Work' with: 'Cell'! !

WAComponent subclass: #PhoneReport
	instanceVariableNames: 'customer phoneAdder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JLLT-EditorsTest'!

!PhoneReport class methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 23:03'!
for: customer

	^self new initializeFor: customer! !

!PhoneReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/22/2009 11:14'!
addPhoneAfter: aPhone
| newPhone |

	newPhone := Phone new.
	phoneAdder prepareToAdd: newPhone after: aPhone in: customer.
	( self call: phoneAdder )	
		ifTrue: [ self halt. customer addPhone: phoneAdder phone after: aPhone ]! !

!PhoneReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 22:35'!
children

	^Array with: phoneEditor! !

!PhoneReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 23:50'!
customer

	^customer! !

!PhoneReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 23:50'!
customer: anObject

	customer := anObject! !

!PhoneReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/22/2009 10:51'!
initialize

	super initialize.
	phoneAdder := PhoneAdder new.! !

!PhoneReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 23:00'!
renderContentOn: html

	html table: [ 
		self renderHeaderRowOn: html.
		customer phones do: [ :phone |
			self renderRowFor: phone On: html ]]! !

!PhoneReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/20/2009 23:13'!
renderHeaderRowOn: html.

	html tableHead: [
		html tableData: [ html text: 'Phone' ].
		html tableData: [  ].
		html tableData: [  ]]! !

!PhoneReport methodsFor: 'as yet unclassified' stamp: 'JLLT 5/22/2009 11:06'!
renderRowFor: phone On: html

	html tableRow: [
		html tableData: [ html text: phone number ].
		html tableData: [ html text: phone type ].
		html tableData: [ html anchor callback: [ self addPhoneAfter: phone ]; with: 'Add' ]]! !
